<?php
/**
 * 获取关联带出值
 * @param
 * @return
 * @author Chj
 */
class cls_RelatedEntryField_Data
{
	private $curmodule;	//当前模块
	private $columnname;	//当前界面的触发字段
	private $hrefcolumn_value = '{hrefcolumn}';//超链接字段在sql中的存储变量值
	public  $LinitemID;
    public $relatedata_arr;
	public function __construct($curmodule,$columnname){
		$this->curmodule = $curmodule;
		$this->columnname = $columnname;
		$this->db = PearDatabase::getInstance();
		$this->trigger_fieldobj=Field::getInstance($this->curmodule,$this->db);
		$this->focus = CRMEntity::getInstance($this->curmodule);
		$this->isProductDetails = 'yes';	//表示带产品分录表体的模块
		if(get_file_address($curmodule,'ProductDetails')){
			crm_load_class_file('ProductToolFields','include/ProductDetails');
			$this->detailfieldobj=ProductToolFields::getInstance($this->curmodule);
			$this->detaildataobj = crm_load_class_obj('cls_productDetailsData',"modules/".$this->curmodule."/ProductDetails",array($this->curmodule));
		}else{
			crm_load_class_file('TabDetailFields','include/TabDetailFields');
			$this->detailfieldobj=TabDetailFields::getInstance($this->curmodule);
			crm_load_class_file('TabDetailFieldsHtmlTd','include/TabDetailFields');
			$this->detaildataobj = new TabDetailFieldsHtmlTd($this->focus,$this->curmodule);
			$this->isProductDetails = 'no';
		}
		$this->param = json_decode($_REQUEST['param'],true);	//触发字段值
         
	}
    
    public function getSelectSourceRelateColumns($relatedtype,$triggermodule)
    {
        $triggerfocus=CRMEntity::getInstance($triggermodule);
        $maincolumn_arr=[];
        $info_arr=$this->getEntityTypeRelateInfo($relatedtype,$triggermodule);
        foreach($info_arr['main']  as $tmpinfo)
        {
            $maincolumn_arr[$tmpinfo['effect_columnname']]=$tmpinfo['column'];
            
        }
        foreach($info_arr['detail']  as $tmpinfo)
        {
            $triggercolumn=$tmpinfo['column'];
            $effect_column=$tmpinfo['effect_columnname'];
            $fieldinfo=$triggerfocus->detailfieldobj->getFieldInfoobjBykey("columnname",$triggercolumn);
            if(!$fieldinfo)
                continue;
            $tablename=$fieldinfo->getTableName();
            $Detailcolumn_arr[$effect_column]="$tablename.$triggercolumn as $effect_column ";
            
                
            
        }
        $column_arr['detailcolumn']=$Detailcolumn_arr;
        $column_arr['maincolumn']=$maincolumn_arr;
        return $column_arr;
    }
    public function getEntityTypeRelateInfo($relatedtype,$triggermodule)
    {
         $RelatedFieldInfo = $this->getRelatedFieldInfo($relatedtype );
         $tmp_arr=[];
        
         foreach($RelatedFieldInfo as $fromvalue_type => $arr)
         {
            
            if($fromvalue_type=='selectsource'){
                
                foreach($arr as $arrinfo)
                {
                   // dump($arrinfo);
                    $fromvalue_info_arr = json_decode(html_entity_decode($arrinfo['fromvalue_info']),true);
                    $columntype='main';
                 //dump($fromvalue_info_arr);
                
                   // $tmpret_arr=[];
                    foreach($fromvalue_info_arr as &$tmpvalueinfo )
                    {
                        
                        if($tmpvalueinfo['module']==$triggermodule)
                        {
                                if(array_key_exists("columntype",$tmpvalueinfo))
                                {
                                    $columntype=$tmpvalueinfo['columntype'];
                                }
                             $tmpvalueinfo['effect_columnname']=$arrinfo['effect_columnname'];
                            $tmp_arr[$columntype][]=$tmpvalueinfo;
                        }
                    }
                   
                   
                    
                }
            }
         }
        
         return $tmp_arr;
    }
	public function getData(){
		$data = array();
       
		if(!empty($this->columnname)){
			$RelatedFieldInfo = $this->getRelatedFieldInfo($_REQUEST['relatedtype']);
         
			foreach($RelatedFieldInfo as $fromvalue_type => $arr){
				if($fromvalue_type == 'column'){
					$data[] = $this->getTriggerDataForColumn($arr);
				}else if($fromvalue_type == 'sql'){
					$data[] = $this->getTriggerDataForSql($arr);
				}else if($fromvalue_type == 'selectsource'){
					$relatedfields = $this->getTriggerDataForSelectsource($arr);
					if(!empty($relatedfields)){
						foreach($relatedfields as $info){
							$data[] = $info;
						}
					}
				}
                else if($fromvalue_type=='entitytype'){
                   
					$relatedfields = $this->getTriggerDataForEntitytype($arr);
                  
				    	if(!empty($relatedfields)){
    						foreach($relatedfields as $info){
    							$data[] = $info;
    						}
					   }
				}
                
			}
			/*echo '<pre>';
			print_r($data);
			echo '</pre>';
			die;*/
			return $data;
		}
       
		return $data;
	}
    
    public function setLinitemID($LinitemID)
    {
       
       
        $this->LinitemID=$LinitemID;
    }
    public function setEntityType($entitytype)
    {
        $this->entitytype=$entitytype;
    }
    private function getTriggerDataForEntitytype($relatedinfos)
    {
        global $adb;
        //获取源单剩余数量
       
        if(empty($this->LinitemID))
        {
            return '';
        }
        // echo $this->LinitemID."aa<br>";
        $curmodule_columninfo_arr=[];
        $sourcecolumn_arr=[];
        crm_load_class_file("ProductDetails",'include/ProductDetails');
        foreach($relatedinfos as  $key=>$arr)
        {
            $frommodule=$arr['frommodule'];
            if($this->entitytype!=$frommodule)
            {
                continue;
            }
            $fromfocus=CRMEntity::getInstance($frommodule);
            $fromvalue_info=$arr['fromvalue_info'];
            $curmodule_columninfo=$arr['curmodule_columninfo'];
            $effect_columnname=$arr['effect_columnname'];
           
            $effectfieldinfo=$this->focus->detailfieldobj->getFieldInfoobjBykey("columnname",$effect_columnname);
            
            if(!$effectfieldinfo)
                continue;
            $productdetailsobj=ProductDetails::getInstance($frommodule);
            $detailmodulefields=$productdetailsobj->getModuleFields();
            if(!array_key_exists($fromvalue_info,$detailmodulefields))
                continue;
             $curmodule_columninfo_arr[]=array('effect_column'=>$effect_columnname,'curmodule_columninfo'=>$curmodule_columninfo);
             $sourcecolumn_arr[]=   $fromvalue_info .' as  '.$curmodule_columninfo;
        }
        if(empty($sourcecolumn_arr))
        {
            return '';
        }
        $detailtable=$fromfocus->Detail_table;
        $detailtablescf=$fromfocus->Detail_table_scf;
        $sql='select '.implode(",",$sourcecolumn_arr )." from $detailtable left join $detailtablescf on $detailtablescf.lineitem_id=$detailtable.lineitem_id
        where $detailtable.lineitem_id=?";
        
      
        $result=$adb->pquery($sql,array($this->LinitemID));
        $rows=$adb->num_rows($result);
        $ret_arr=[];
        crm_load_class_file("showProductDetailFieldValue",'include/fields');
        
        foreach($curmodule_columninfo_arr as $tmpindex=>$tmp_arr)
        {
            $curmodule_columninfo=$tmp_arr['curmodule_columninfo'];
            $effectfieldinfo=$this->focus->detailfieldobj->getFieldInfoobjBykey("columnname",$tmp_arr['effect_column']);
           	$showfieldvalueobj=new showProductDetailFieldValue($effectfieldinfo,$arr['frommodule'],SHOW_EDITVIEW);
            $value=$adb->query_result($result,0,$tmp_arr['curmodule_columninfo']);
		
			$showvalue=$showfieldvalueobj->getFieldValueByField($effectfieldinfo,$value,$value);
          
            $ret_arr[$tmpindex]['bigtype']=$effectfieldinfo->getBigType();
            $ret_arr[$tmpindex]['value'][$tmp_arr['curmodule_columninfo']]=$showvalue['value'];
            $ret_arr[$tmpindex]['isproductdetail']='yes';
        }
        $tmparr[0]=$ret_arr;
        return $tmparr;
        
    }
	//源单 引用取值
	private function getTriggerDataForSelectsource($relatedinfos){
		if(!empty($relatedinfos)){
			$relatedmodule_array = array();
           
			foreach($relatedinfos as $key => $arr){
				$fromvalue_info_array = ldcrm_json_decode(decode_html($arr['fromvalue_info']));
              
				foreach($fromvalue_info_array as $arrs){
					//单据查看、编辑界面，$_REQUEST['selectmodule'] 没有值
					if(!empty($_REQUEST['selectmodule']) && $_REQUEST['selectmodule'] != $arrs['module'])continue;
					if(!empty($arrs['column'])){
						$arr['fromvalue_type'] = 'column';
					}else if(!empty($arrs['sql'])){
						$arr['fromvalue_type'] = 'sql';
					}
                    //获取字段值所在类型，主表：main；分录：detail;
                    $arr['columntype'] = $arrs['columntype'];
                    if(empty($arr['columntype'])){
                        $arr['columntype'] = 'main';
                    }
					$arr['frommodule'] = $arrs['module'];
					$arr['fromvalue_info'] = $arrs['column'];
					$relatedmodule_array[$arr['fromvalue_type']][] = $arr;
				}
			}
            
			if(!empty($relatedmodule_array)){
				foreach($relatedmodule_array as $fromvalue_type => $arr){
					if($fromvalue_type == 'column'){
						$data[] = $this->getTriggerDataForColumn($arr);
					}else if($fromvalue_type == 'sql'){
						$data[] = $this->getTriggerDataForSql($arr);
					}
				}
			}
		}

		return $data;
		
	}
	//处理sql中的问号
	private function getResultQuery($query){
		if(!empty($query)){
			$query = decode_html($query);
			foreach ($this->param as $key=>$val){
                $query =  str_replace('{'.$key.'}',$val,$query);
            }
			$result = $this->db->pquery($query,array());
		}
		return $result;
	}

	//根据column获取关联带出的数据
	private function getTriggerDataForColumn($relatedinfos){
		$data = array();
        global $$reset_retrieve_entity_info;
       
		if(!empty($relatedinfos)){
			$effect_module = $relatedinfos[0]['frommodule'];
        
			if(!empty($effect_module)){
			 
			
		
				if(!empty($this->param[$relatedinfos[0]['trigger_columnname']])){
					if($relatedinfos[0]['trigger_columnname'] == 'entitytypeid'){
						$effect_module = getSalesEntityType($this->param[$relatedinfos[0]['trigger_columnname']]);
					}
                      
                //edit:can 54142 昊天祥泰）从商机或者合同关联创建出资申请单时，源单类型无法正常带入，导致分录取不到值 
					$focus = CRMEntity::getInstance($effect_module);
    	            $effect_fieldobj=Field::getInstance($effect_module,$this->db);
                    $reset_retrieve_entity_info='yes';
                  	$focus = CRMEntity::getInstance($effect_module);
					$focus->retrieve_entity_info($this->param[$relatedinfos[0]['trigger_columnname']],$effect_module);
					$col_fields=$focus->column_fields;
                  
					foreach($relatedinfos as $key => $arr){
					   if($arr['frommodule']!=$effect_module)
                        continue;
					   //zkt 20220629 1000143  采购订单、收付款单、出入库单，分录明细增加“合同订单”字段（咏睿）
                        if(array_key_exists("columntype",$arr)&&$arr['columntype'] == 'detail')
                        {
                            $detailfield = $this->getSelectSourceTriggerDataForEntitytype($arr);
                            $data[$key] = $detailfield;
                            continue;
                        }
						$field=$effect_fieldobj->getFieldInfoobjBykey('columnname',$arr['fromvalue_info']);
                 
						if(!empty($field)){
							$showfieldvalueobj=new ShowFieldValue($effect_fieldobj,$arr['frommodule'],SHOW_EDITVIEW);
							$fieldname = $field->getFieldName();
							$showvalue=$showfieldvalueobj->getFieldValueByField($field,$col_fields[$fieldname],$col_fields[$fieldname]);
                             
							$value = $showvalue['value'];
                            if(!empty($this->detaildataobj)){
                                $cur_effectfieldobj = $this->detailfieldobj->getFieldInfoobjBykey('columnname',$arr['effect_columnname']);
                                if(!empty($cur_effectfieldobj)){
                                    if($cur_effectfieldobj->getBigType()=='relatedmodulefield'&&$cur_effectfieldobj->getSaveDataBase()=='yes')
                                    {
                                       if($cur_effectfieldobj->getParentBigType()=='reference')
                                       {
                                       //$showvalue['rawvalue']=$showvalue['value'];
                                       }
                                      else
                                        $showvalue['rawvalue']=$showvalue['value'];
                                       
                                    }
                                    $data[$key]['parentbigtype'] = $cur_effectfieldobj->getParentBigType();
                                    
                                    
                                    if($cur_effectfieldobj->getBigType() == 'relatedmodulefield'&&($cur_effectfieldobj->getParentBigType()=='reference')){
                                        //源单引用主表关联选择单据字段， columnname_name返回值，用于PC端界面赋值
                                        $data[$key]['value'][$arr['curmodule_columninfo'].'_name']=$showvalue['value'];
                                        $data[$key]['rawvalue'][$arr['curmodule_columninfo'].'_name']=$showvalue['value'];
                                    }
                                }
                                
                            }
                            
							if($value == '0000-00-00')$value = '';
							if($field->getBigType() == 'multipicklist'){
								$value=str_replace(" |##| ",',',$value);
							}
							$data[$key]['bigtype'] = $arr['bigtype'];
							$data[$key]['value'][$arr['curmodule_columninfo']] = $value;
							$data[$key]['isproductdetails'] = $this->isProductDetails;
                            
							$data[$key]['rawvalue'][$arr['curmodule_columninfo']]=$showvalue['rawvalue'];
						}
					}
				}
			}
		}
		return $data;
	}
	//zkt 20220629 1000143  采购订单、收付款单、出入库单，分录明细增加“合同订单”字段（咏睿）
    //获取源单带出明细
    private function getSelectSourceTriggerDataForEntitytype($relatedinfos)
    {
        global $adb;
       
        if(empty($this->LinitemID)||$relatedinfos['columntype']!='detail')
        {
            return '';
        }
         
        $curmodule_columninfo_arr=[];
        $sourcecolumn_arr=[];
        crm_load_class_file("ProductDetails",'include/ProductDetails');
        $arr = $relatedinfos;
        $frommodule=$arr['frommodule'];
        $fromfocus=CRMEntity::getInstance($frommodule);
        $fromvalue_info=$arr['fromvalue_info'];
        $curmodule_columninfo = $arr['curmodule_columninfo'];
        $effect_columnname = $arr['effect_columnname'];
       
        $fromfieldinfo=$fromfocus->detailfieldobj->getFieldInfoobjBykey("columnname",$fromvalue_info);
        
        $productdetailsobj=ProductDetails::getInstance($frommodule);
        $detailmodulefields=$productdetailsobj->getModuleFields();
         $curmodule_columninfo_arr=array('effect_column'=>$effect_columnname,'curmodule_columninfo'=>$curmodule_columninfo);
         $sourcecolumn_arr=   $fromvalue_info .' as  '.$curmodule_columninfo;
        
        $detailtable=$fromfocus->Detail_table;
        $detailtablescf=$fromfocus->Detail_table_scf;
        $sql='select '.$sourcecolumn_arr ." from $detailtable left join $detailtablescf on $detailtablescf.lineitem_id=$detailtable.lineitem_id
        where $detailtable.lineitem_id=?";
        
      
        $result=$adb->pquery($sql,array($this->LinitemID));
        $rows=$adb->num_rows($result);
        $ret_arr=[];
        crm_load_class_file("showProductDetailFieldValue",'include/fields');
        if($rows>0){
            $tmp_arr = $curmodule_columninfo_arr;
            $showfieldvalueobj=new showProductDetailFieldValue($fromfieldinfo,$arr['frommodule'],SHOW_EDITVIEW);
            $value=$adb->query_result($result,0,$tmp_arr['curmodule_columninfo']);
            
            $fromshowvalue=$showfieldvalueobj->getFieldValueByField($fromfieldinfo,$value,$value);
            
            
            
            $curmodule_columninfo=$tmp_arr['curmodule_columninfo'];
            $effectfieldinfo=$this->focus->detailfieldobj->getFieldInfoobjBykey("columnname",$tmp_arr['effect_column']);
            /*$showfieldvalueobj=new showProductDetailFieldValue($effectfieldinfo,$arr['frommodule'],SHOW_EDITVIEW);
            $value=$adb->query_result($result,0,$tmp_arr['curmodule_columninfo']);
			$showvalue=$showfieldvalueobj->getFieldValueByField($effectfieldinfo,$value,$value);  */
          
            $ret_arr['bigtype']=$effectfieldinfo->getBigType();
            $ret_arr['value'][$tmp_arr['curmodule_columninfo']]=$fromshowvalue['value'];
            $ret_arr['rawvalue'][$tmp_arr['curmodule_columninfo']]=$fromshowvalue['rawvalue'];
            if($effectfieldinfo->getBigType() == 'relatedmodulefield'&&($effectfieldinfo->getParentBigType()=='reference'||$effectfieldinfo->getParentBigType()=='selectsource')){
                //源单引用关联选择单据字段，证据 columnname_name返回值
                $ret_arr['value'][$tmp_arr['curmodule_columninfo'].'_name']=$fromshowvalue['value'];
                $ret_arr['rawvalue'][$tmp_arr['curmodule_columninfo'].'_name']=$fromshowvalue['value'];
            }
            
            if($effectfieldinfo->getBigType()=='relatedmodulefield'&&$effectfieldinfo->getSaveDataBase()=='yes')
            {
               if($effectfieldinfo->getParentBigType()=='reference'||$effectfieldinfo->getParentBigType()=='selectsource')
               {
               //$showvalue['rawvalue']=$showvalue['value'];
               }
              else
                $showvalue['rawvalue']=$showvalue['value'];
               
            }
            $ret_arr['parentbigtype'] = $effectfieldinfo->getParentBigType();
            $ret_arr['isproductdetail']='yes';
        }
        return $ret_arr;
        
    }

	//根据sql获取关联带出的数据
	private function getTriggerDataForSql($relatedinfos){
		$data = array();
		if(!empty($relatedinfos)){
			foreach($relatedinfos as $key => $arr){
				if(!empty($arr['fromvalue_info'])){
					$query = $arr['fromvalue_info'];
					if(strpos($query, $this->hrefcolumn_value)){
						$detailfield=$this->detailfieldobj->getFieldInfoobjBykey('columnname',$arr['effect_columnname']);
						if($detailfield->getBigType() == 'reference'){
							$effect_module = $detailfield->getReferenceModule();
						}
						$entityarray = getEntitynameInfo(getTabid($effect_module));
						$hrefcolumn_replace_value = $entityarray['tablename'] . '.' . $entityarray['fieldname'];
						$query = str_replace($this->hrefcolumn_value,$hrefcolumn_replace_value,$query);
					}
					$result = $this->getResultQuery($query);
					$num_rows = $this->db->num_rows($result);
					if($num_rows >= 1){
						$curmodule_columns = explode(',',$arr['curmodule_columninfo']);
						$data[$key]['bigtype'] = $arr['bigtype'];
						$data[$key]['isproductdetails'] = $this->isProductDetails;
						foreach($curmodule_columns as $column){
							$data[$key]['value'][$column] = $this->db->query_result($result,0,$column);
						}
					}
				}
			}
		}
		return $data;
	}
	//获取需要清除的引用关联字段
	public function getClearData(){
		$relatedmodulefields = $this->getRelatedFieldInfo('trigger');
		foreach($relatedmodulefields as $fromvalue_type => $relatedinfos){
			foreach($relatedinfos as $key => $arr){
				$detailfield=$this->detailfieldobj->getFieldInfoobjBykey('columnname',$arr['effect_columnname']);
				$decimal_digits = '';
				$typeofdatas = explode('~',$arr['typeofdata']);
				$value = '';
				if($arr['bigtype'] == 'relatedmodulefield' && ($typeofdatas[0] == 'N' || $typeofdatas[0] == 'NN')){
					if($this->isProductDetails == 'yes'){
						$decimal_digits = $this->detaildataobj->getDecimalDigits($detailfield,$arr['typeofdata']);
						if(!empty($decimal_digits)){
							$value = sprintf('%.'.$decimal_digits.'f',0);
						}
					}else{
						$decimal_digits = $this->detaildataobj->getColumnValue($detailfield,$arr['effect_columnname'],0,SHOW_EDITVIEW);
						$value = $decimal_digits['value'];
					}
				}
				
				
				$data[] = array(
					'bigtype' => $arr['bigtype'],	//bigtype类型
					'curmodule_columninfo' => $arr['curmodule_columninfo'],
					'value' => $value,
					'isproductdetails' => $this->isProductDetails
				);
				
			}
		}
		return $data;
	}
	//获取引用字段信息
	private function getRelatedFieldInfo($relatedtype = ''){
	   if(is_array($this->relatedata_arr))
       {
        return $this->relatedata_arr;
       }
		if($relatedtype == 'trigger'){
			$query = 'select trigger_columnname,effect_columnname,curmodule_columninfo,fromvalue_type,fromvalue_info,frommodule from ld_related_detailfield where modulename = ? and trigger_columnname = ?';
			$result = $this->db->pquery($query,array($this->curmodule,$this->columnname));
           
		}else{
			$columns = explode(',',$this->columnname);
			$columns = "'".implode("','",$columns)."'";
			$query = 'select trigger_columnname,effect_columnname,curmodule_columninfo,fromvalue_type,fromvalue_info,frommodule from ld_related_detailfield where modulename = ? and effect_columnname in ('.$columns.')';
			$result = $this->db->pquery($query,array($this->curmodule));
		}
      
		$num_rows = $this->db->num_rows($result);
		$data = array();
		if($num_rows > 0){
			for($i = 0; $i < $num_rows; $i++){
				$fromvalue_type = $this->db->query_result($result,$i,'fromvalue_type');
				$effect_columnname = $this->db->query_result($result,$i,'effect_columnname');
               
				$detailfield=$this->detailfieldobj->getFieldInfoobjBykey('columnname',$effect_columnname);
                //edit:can 20210408 045358: （61mis.com/kfbcrm）分录引用字段功能；采购管理-采购询价单-新建；分录中关联单选了日程源单，新建时，选择日程单据后，界面一直转圈，后台有报错
               if(!isset($detailfield)||$detailfield->getColumnName()=='')
                    continue;
                
				$data[$fromvalue_type][] = array(
					'trigger_columnname' => $this->db->query_result($result,$i,'trigger_columnname'),
					'effect_columnname' => $this->db->query_result($result,$i,'effect_columnname'),
					'curmodule_columninfo' => $this->db->query_result($result,$i,'curmodule_columninfo'),
					'fromvalue_type' => $this->db->query_result($result,$i,'fromvalue_type'),
					'fromvalue_info' => $this->db->query_result($result,$i,'fromvalue_info'),
					'frommodule' => $this->db->query_result($result,$i,'frommodule'),
					'bigtype' => $detailfield->getBigType(),
					'typeofdata' => $detailfield->getTypeOfData()
				);
			}
		}
        $this->relatedata_arr=$data;
		return $data;
	}
	
	//根据引用字段获取对应的值
	public function getDataForColumn(){
		$data = array();
		if(!empty($this->columnname)){
			$RelatedFieldInfo = $this->getRelatedFieldInfo($_REQUEST['relatedtype']);
           
			foreach($RelatedFieldInfo as $fromvalue_type => $arr){
				if($fromvalue_type == 'column'){
					$data[] = $this->getTriggerDataForColumn($arr);
				}else if($fromvalue_type == 'sql'){
					$data[] = $this->getTriggerDataForSql($arr);
				}else if($fromvalue_type == 'selectsource'){
					$relatedfields = $this->getTriggerDataForSelectsource($arr);
					if(!empty($relatedfields)){
						foreach($relatedfields as $info){
							$data[] = $info;
						}
					}
				}
                 else if($fromvalue_type=='entitytype'){
					$relatedfields = $this->getTriggerDataForEntitytype($arr);
                  
				    	if(!empty($relatedfields)){
    						foreach($relatedfields as $info){
    							$data[] = $info;
    						}
					   }
				}
			}
		}
		if(!empty($data)){
			$res = array();
			foreach($data as $relatedvalues){
				foreach($relatedvalues as $relateds){
					foreach($relateds as $stype => $vals){
						if($stype == 'rawvalue'){
							$keys = array_keys($vals);
							$res[$keys[0]] = $vals[$keys[0]];
						}
					}
				}
			}
			return $res;
		}
		return $data;
	}
	
}


?>